<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch">
	  <el-form-item :label="$t('table.commodityType')" prop="commodityName">
		<el-select v-model="queryParams.typeName" :placeholder="$t('placeholder.commodityType')">
			<el-option
				v-for="item,index in queryCommodityTypeList"
				:key="index"
				:label="item.typeName"
				:value="item.typeName">
			</el-option>
		</el-select>
      </el-form-item>
	  <el-form-item :label="$t('table.beginDate')" >
        <el-date-picker clearable
          v-model="queryParams['params[beginDate]']"
          type="date"
          value-format="yyyy-MM-dd"
          :placeholder="$t('placeholder.beginDate')">
        </el-date-picker>
      </el-form-item>
      <el-form-item :label="$t('table.endDate')">
        <el-date-picker clearable
          v-model="queryParams['params[endDate]']"
          type="date"
          value-format="yyyy-MM-dd"
          :placeholder="$t('placeholder.endDate')">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">{{$t('btn.search')}}</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">{{$t('btn.Reset')}}</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['commodityType:commodityType:add']"
        >{{$t('btn.add')}}</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['commodityType:commodityType:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['commodityType:commodityType:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['commodityType:commodityType:export']"
        >导出</el-button>
      </el-col> -->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="commodityTypeList" @selection-change="handleSelectionChange">
      <!-- <el-table-column type="selection" width="55" align="center" /> -->
	  <el-table-column :label="$t('table.SerialNumber')" width="50px" align="center">
		<template slot-scope="scope">
			{{ scope.$index + (queryParams.pageNum - 1) * queryParams.pageSize + 1 }}
		</template>
	  </el-table-column>
      <!-- <el-table-column label="id" align="center" prop="id" /> -->
      <el-table-column :label="$t('table.commodityType')" align="center" prop="typeName" />
	  <el-table-column :label="$t('table.typeImg')" align="center">
		<template slot-scope="scope">
			<img style="width:100px;height:100px" :src='baseUrl+scope.row.typeImg'>
		</template>
	  </el-table-column>
      <!-- <el-table-column label="备注" align="center" prop="remark" /> -->
      <el-table-column :label="$t('table.operation')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['commodityType:commodityType:edit']"
          >{{$t('table.edit')}}</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['commodityType:commodityType:remove']"
          >{{$t('table.delete')}}</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改商品分类信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item :label="$t('table.commodityType')" prop="typeName">
          <el-input v-model="form.typeName" type="text" :placeholder="$t('placeholder.commodityType')" />
        </el-form-item>
		<el-form-item :label="$t('table.typeImg')" >
          <image-upload v-model="form.typeImg" :limit='1'/>
        </el-form-item>
        <!-- <el-form-item label="删除标志：0-正常 1-删除" prop="delFlag">
          <el-input v-model="form.delFlag" placeholder="请输入删除标志：0-正常 1-删除" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item> -->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{$t('btn.submit')}}</el-button>
        <el-button @click="cancel">{{$t('btn.cancel')}}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listCommodityType, getCommodityType, delCommodityType, addCommodityType, updateCommodityType } from "@/api/commodityType/commodityType";

export default {
  name: "CommodityType",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 商品分类信息表格数据
      commodityTypeList: [],
      queryCommodityTypeList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        typeName: null,
		'params[beginDate]':null,
		'params[endDate]':null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
	  baseUrl: process.env.VUE_APP_BASE_API,
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询商品分类信息列表 */
    getList() {
      this.loading = true;
      listCommodityType(this.queryParams).then(response => {
        this.commodityTypeList = response.rows;
        console.log(this.queryCommodityTypeList.length)
        if(this.queryCommodityTypeList.length<=0){
          this.queryCommodityTypeList = response.rows;
        }
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        typeName: null,
        delFlag: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
    //   this.title = "添加商品分类";
	  this.title = this.$t('dialog.commodityTypeTitel1')
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getCommodityType(id).then(response => {
        this.form = response.data;
        this.open = true;
        // this.title = "修改商品分类";
		this.title = this.$t('dialog.commodityTypeTitel2')
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateCommodityType(this.form).then(response => {
              this.$modal.msgSuccess(this.$t('message.success1'));
              this.open = false;
              this.getList();
            });
          } else {
            addCommodityType(this.form).then(response => {
              this.$modal.msgSuccess(this.$t('message.success2'));
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm(this.$t('message.isDelete4')).then(function() {
        return delCommodityType(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess(this.$t('message.success3'));
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('commodityType/commodityType/export', {
        ...this.queryParams
      }, `commodityType_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
